//+------------------------------------------------------------------+
//|                                                     MVC_View.mqh |
//|                                Copyright 2021, Andrei Novichkov. |
//|                    https://www.mql5.com/en/users/andreifx60/news |
//+------------------------------------------------------------------+


/*
//--- indicator buffers
double         lb[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int Initialize() {

   SetIndexBuffer(0, lb, INDICATOR_DATA);
   ArraySetAsSeries(lb, true);
      
   PlotIndexSetString (0, PLOT_LABEL, "Label1");
   PlotIndexSetInteger(0, PLOT_DRAW_TYPE, DRAW_LINE);
   PlotIndexSetInteger(0, PLOT_LINE_COLOR, clrDarkSlateBlue);
   PlotIndexSetInteger(0, PLOT_LINE_STYLE, STYLE_SOLID);
   PlotIndexSetInteger(0, PLOT_LINE_WIDTH, 2);

   return(INIT_SUCCEEDED);
}
*/
class CView {
   public:
      void CView();
      void ResetBuffers();
      int  Initialize();
      void SetData(double value, int shift = 0);
      
   private:
      double _lb[];
      int    _Width;
      string _Name;
      string _Label;      
};// class CView

void CView::CView() {
      _Width = 2;
      _Name  = "Primitive" ;
      _Label = "Label1"; 
}// void CView::CView()

void CView::ResetBuffers(){
   ArrayInitialize(_lb, EMPTY_VALUE);
}

int CView::Initialize() {
      SetIndexBuffer(0, _lb, INDICATOR_DATA);
      ArraySetAsSeries(_lb, true);
   
      IndicatorSetString (INDICATOR_SHORTNAME, _Name);
      IndicatorSetInteger(INDICATOR_DIGITS, _Digits);
   
      PlotIndexSetString (0, PLOT_LABEL, _Label);
      PlotIndexSetInteger(0, PLOT_DRAW_TYPE, DRAW_LINE);
      PlotIndexSetInteger(0, PLOT_LINE_COLOR, clrDarkSlateBlue);
      PlotIndexSetInteger(0, PLOT_LINE_STYLE, STYLE_SOLID);
      PlotIndexSetInteger(0, PLOT_LINE_WIDTH, _Width);   
      
      return(INIT_SUCCEEDED);   
}

void CView::SetData(double value,int shift) {
   
   _lb[shift] = value;
}